
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientFloat32. See ClientByte.cc
//
// 3/29/99 jhrg

// $Log: ClientFloat32.cc,v $
// Revision 1.2.8.1  1999/11/02 23:48:46  jimg
// Bug: used dods_float64 instead of dods_float32
//
// Revision 1.2  1999/04/30 17:06:54  jimg
// Merged with no-gnu and release-2-24
//
// Revision 1.1  1999/03/29 21:22:55  jimg
// Added
//

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>
#include <iomanip.h>

#include <string>

#include "dods-limits.h"
#include "ClientFloat32.h"
#include "name_map.h"

extern name_map names;
extern bool translate;
extern bool ascii;

Float32 *
NewFloat32(const string &n)
{
    return new ClientFloat32(n);
}

ClientFloat32::ClientFloat32(const string &n) : Float32(n)
{
}

BaseType *
ClientFloat32::ptr_duplicate()
{
    return new ClientFloat32(*this);
}
 
bool
ClientFloat32::read(const string &, int &)
{
    assert(false);
    return false;
}

void 
ClientFloat32::print_val(ostream &os, string, bool print_decl_p)
{
    os.precision(DODS_FLT_DIG);

    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (translate) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << _buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_float32));
    }
}
